   1 REM Dungeon Master's
   2 REM Character Sheet
   3 REM BK8410-007074DungMastCharSheet
   4 REM Written By
   5 REM Peter R. Fleming
   6 REM
   8 GO SUB 9900
   9 LET cls=9000

  10 REM Start
  20 INK 0: PAPER 7: BORDER 7: FLASH 0: BRIGHT 1: OVER 0:
     INVERSE 0: GO SUB 9050
  22 GO SUB cls
  30 PRINT AT 3,6; INVERSE 1; INK 3;"D.M. Character Sheet"
  35 PRINT AT 5,3;"Options:-": PLOT 24,127: DRAW 71,0
  40 FOR x=1 TO 7: PRINT AT x*2+5,3;o$(x) : NEXT x
  50 LET a$=INKEY$: IF a$="" OR a$< CHR$ 49 OR a$> CHR$ 55 THEN GO TO 50
  60 LET a=(CODE a$)-48: BEEP .1,5: PRINT AT a*2+5,3; INVERSE 1; o$(a): GO TO a*500

 190 REM Variable set-up & SAVE
 200 DIM p$(15,13)
 205 DIM a(15,7)
 210 DIM s$(15,6)
 215 DIM r$(15,9)
 220 DIM h(15,3)
 225 DIM c$(15,9)
 230 DIM q$(15,9)
 235 DIM w$(15,20)
 240 DIM o$(7,26)
 250 GO SUB 1405
 260 GO SUB 9850
 270 SAVE "Character" LINE 1
 280 PRINT "Verify": VERIFY ""
 290 PRINT "Verified O.K."
 300 STOP

 500 REM List character sheet
 501 GO SUB 505
 502 PRINT AT 18,2; FLASH 1;"Press key to return to menu.":
     IF INKEY$="" THEN GO TO 502
 503 BEEP .1,5: GO TO 22
 505 GO SUB cls: PRINT AT 3,3;"No.  Player     Character"
 510 PLOT 24,143: DRAW 23,0: PLOT 64,143: DRAW 47,0: PLOT 152,143: DRAW 71,0
 515 FOR z=1 TO 15:
       PRINT OVER 1;AT z+4,3;z;TAB 8;p$(z);AT z+4,19;q$(z):
     NEXT z
 520 INPUT "Input character No. ";player:
     IF player>15 OR player<1 THEN GO TO 520
 525 CLS
 530 GO SUB 9050
 535 PRINT AT 3,6; INVERSE 1; INK 3;"Character sheet No.";player
 540 PRINT AT 5,3;"Players Name:";p$(player);AT 7,3;"Name  :";q$(player);
           AT 8,3;"Race  :";r$(player)
 545 PRINT AT 9,3;"Class :";c$(player);AT 9,20;"Str:";a(player,1);:
     IF a(player,2)<>0 AND a(player,2)<>100 THEN PRINT "/";a(player)
 550 IF a(player,2)=100 THEN PRINT "/00"
 555 PRINT AT 10,3;"Sex   :";s$(player);AT 10,20;"Int:";a(player,3);
           AT 11,20;"Wis:";a(player,4);AT 12,3;"Age   :";h(player,1);"yrs"
 560 PRINT AT 12,20;"Con:";a(player,5);AT 13,3;"Height:";h(player,2);"~";
           AT 13,20;"Dex:";a(player,7);AT 14,3;"Weight:";h(player,3);"#";
           AT 14,20;"Cha:";a(player,3)
 600 RETURN

1000 REM Adjust character sheet
1005 GO SUB cls: PRINT AT 3,3;"No.  Player     Character"
1010 PLOT 24,143: DRAW 23,0: PLOT 64,143: DRAW 47,0: PLOT 152,143: DRAW 71,0
1015 FOR z=1 TO 15:
       PRINT AT z+4,3;z;TAB 8;p$(z);AT z+4,19;q$(z):
     NEXT z
1020 INPUT "Character No.";player
1030 GO SUB cls
1035 PRINT AT 3,3;"Choose which adjustment"
1040 PLOT 24,143: DRAW 183,0
1045 FOR z=1 TO 15: PRINT AT z+4,3;z;TAB 7;w$(z) : NEXT z
1050 INPUT "Enter adjustment No.";adjust:
     IF adjust<1 OR adjust>15 THEN GO TO 1050
1055 PRINT AT adjust+4,3; FLASH 1;adjust;TAB 7;w$(adjust)
1060 GO SUB adjust*10+1100
1065 INPUT "Any more Adjustments? ";z$:
     IF z$="y" OR z$="Y" THEN
       PRINT AT adjust+4,3;adjust;TAB 7;w$(adjust):
       GO TO 1050
1070 IF z$="n" OR z$="N" THEN
       GO TO 22
1075 GO TO 1065
1100 STOP

1110 INPUT p$(player)
1119 RETURN
1120 INPUT q$(player)
1129 RETURN
1130 INPUT r$(player)
1139 RETURN
1140 INPUT c$(player)
1149 RETURN
1150 INPUT s$(player)
1159 RETURN
1160 INPUT h(player,1)
1169 RETURN
1170 INPUT h(player,2)
1179 RETURN
1180 INPUT h(player,3)
1189 RETURN
1190 INPUT a(player,1)
1199 RETURN
1200 INPUT a(player,2)
1209 RETURN
1210 INPUT a(player,3)
1219 RETURN
1220 INPUT a(player,4)
1229 RETURN
1230 INPUT a(player,5)
1239 RETURN
1240 INPUT a(player,6)
1249 RETURN
1250 INPUT a(player,7)
1259 RETURN

1400 DATA "Player's Name","Character's Name","Race","Class",
          "Sex","Age","Height","Weight","Str","Xstr","Int",
          "Wis","Con","Dex","Cha"
1405 RESTORE 1400: FOR z=1 TO 15: READ w$(z): NEXT z
1410 RETURN

1500 REM Copy character sheet
1505 GO SUB 505
1510 PRINT AT 18,4; FLASH 1;"Do you want this copied?"
1515 LET z$=INKEY$:
     IF z$="n" OR z$="N" THEN BEEP .1,5: GO TO 502
1520 IF z$="y" OR z$="Y" THEN BEEP .1,5: GO TO 1530
1525 GO TO 1515
1530 PRINT AT 18,4;TAB 28
1535 COPY
1540 GO TO 502

2000 REM Enter new character
2005 GO SUB cls
2010 PRINT AT 3,6; INVERSE 1; INK 3;"New character sheet"
2015 PRINT AT 5,3;"Please enter number of";
           AT 6,3;"character sheet you wish";
           AT 7,3;"to use. If you wish to use";
           AT 8,3;"the first available sheet";
           AT 9,3;"then just press ENTER."
2020 INPUT LINE z$:
     IF z$<>"" THEN IF VAL z$<>15 OR VAL z$<0 THEN GO TO 2020
2025 IF CODE z$<>0 THEN LET player=VAL z$: GO TO 2040
2030 FOR z=1 TO 15
2035   IF a(z,1)<>0 THEN
     NEXT z
2040 LET player=z
2045 GO SUB cls
2050 PRINT AT 3,6; INVERSE 1; INK 3;"New character sheet"
2055 PRINT AT 5,3;"Players Name: ";
           AT 7,3;"Name  :";
           AT 8,3;"Race  :";
           AT 9,3;"Class :          Str:";
           AT 10,3;"Sex   :          Int:";
           AT 11,20;"Wis:";
           AT 12,3;"Age   :          Con:";
           AT 13,3;"Height:          Dex:";
           AT 14,3;"Weight:          Cha:"
2060 PRINT AT 18,3; FLASH 1;"Players Name?":
     INPUT p$(player): PRINT AT 5,16;p$(player)
2065 PRINT AT 18,3; FLASH 1;"Characters Name?":
     INPUT q$(player): PRINT AT 7,10;q$(player)
2070 PRINT AT 18,3; FLASH 1;"Characters Race?":
     INPUT r$(player): PRINT AT 8,10;r$(player)
2075 PRINT AT 18,3; FLASH 1;"Characters Class?":
     INPUT c$(player): PRINT AT 9,10;c$(player)
2080 PRINT AT 18,3; FLASH 1;"Characters Sex?"; FLASH 0;"  ":
     INPUT s$(player):
     IF s$(player,1)="F" OR s$(player,1)="f" THEN LET s$(player)="Female": GO TO 2095
2085 IF s$(player,1)="M" OR s$(player,1)="m" THEN LET s$(player)="Male":GO TO 2095
2090 GO TO 2080
2095 PRINT AT 10,10;s$(player)
2100 PRINT AT 18,3; FLASH 1;"Characters Age?":
     INPUT h(player,1): IF h(player,1)<1 THEN GO TO 2100
2102 PRINT AT 12,10;h(player,1);"yrs"
2105 PRINT AT 18,3; FLASH 1;"Characters Height?":
     INPUT h(player,2): IF h(player,2)<1 THEN GO TO 2105
2107 PRINT AT 13,10;h(player,2);"~"
2110 PRINT AT 18,3; FLASH 1;"Characters Weight?":
     INPUT h(player,3): IF h(player,3)<1 THEN GO TO 2110
2112 PRINT AT 14,10;h(player,3);"#"
2115 PRINT AT 18,3; FLASH 1;"Characters Attributes?":
     INPUT "Str:";a(player,1): PRINT AT 9,24;a(player,1)
2120 IF a(player,1)=18 THEN
       INPUT "Exceptional Str:";a(player,2):
       PRINT AT 9,26;"/";a(player,2)
2125 INPUT "Int:";a(player,3): PRINT AT 10,24;a(player,3)
2130 INPUT "Wis:";a(player,4): PRINT AT 11,24;a(player,4)
2135 INPUT "Con:";a(player,5): PRINT AT 12,24;a(player,5)
2140 INPUT "Dex:";a(player,6): PRINT AT 13,24;a(player,6)
2145 INPUT "Cha:";a(player,7): PRINT AT 14,24;a(player,7)
2150 PRINT AT 18,2; FLASH 1;"Press key to return to menu."
2155 IF INKEY$=CHR$ 13 THEN GO TO 2155
2160 IF INKEY$="" THEN GO TO 2160
2165 BEEP .1,5
2170 GO TO 22

2500 REM Clear One character
2510 GO SUB cls
2520 PRINT AT 3,6; INVERSE 1; INK 3;"Clear One Character"
2530 FOR z=1 TO 15:
       PRINT AT z+4,3;z;TAB 7;p$(z);TAB 20;q$(z):
     NEXT z
2540 INPUT "Choose character ";player:
     IF player>15 OR player<1 THEN GO TO 2540
2550 GO SUB cls
2560 PRINT AT 3,6; INVERSE 1; INK 3;"Clear One Character"
2570 PRINT AT 6,3;"Are you sure you want this";
           AT 7,3;"deleted?(y/n)"
2580 LET z$=INKEY$: IF INKEY$="" THEN GO TO 2580
2590 IF z$="y" OR z$="Y" THEN BEEP .1,5: GO TO 2620
2600 IF z$="n" OR z$="N" THEN BEEP .1,5: GO TO 22
2610 GO TO 2580

2620 LET q$(player)=""
2625 LET p$(player)=""
2630 LET r$(player)=""
2635 LET c$(player)=""
2640 LET s$(player)=""
2645 FOR z=1 TO 7
2650   LET a(player,z)=0
2655 NEXT z
2660 FOR z=1 TO 3
2665   LET h(player,z)=0
2670 NEXT z
2680 PRINT AT 9,3;"Character No.";player;" Cleared";
           AT 10,3;"from memory banks."
2690 GO TO 502

3000 REM Clear all characters
3010 GO SUB cls
3020 PRINT AT 3,6; BRIGHT 1;INVERSE 1; INK 3;"Clear all characters";
3030 PRINT AT 6,3; BRIGHT 1;FLASH 1; INK 2; PAPER 6;
           "                          ";
           AT 7,3;"         "; INVERSE 1;"WARNING";
                  INVERSE 0;TAB 28;" ";
           AT 8,3;" ONCE CLEARED ALL         ";
           AT 9,3;" CHARACTERS ARE LOST      ";
          AT 10,3;" COMPLETELY.              ";
          AT 11,3;TAB 28;" "
3040 INPUT "Enter ""CLEAR"" to clear ";z$:
     IF z$="CLEAR" OR z$="clear" THEN GO TO 3060
3050 GO TO 22

3060 FOR r=1 TO 15
3070   LET q$(r)=""
3080   LET p$(r)=""
3090   LET r$(r)=""
3100   LET c$(r)=""
3110   LET s$(r)=""
3120   FOR x=1 TO 7
3130     LET a(r,x)=0
3140   NEXT x
3150   FOR x=1 TO 3
3160     LET h(r,x)=0
3170   NEXT x
3180 NEXT r
3190 PRINT AT 6,3;TAB 28;" ";
           AT 7,3;"All characters cleared   ";
           AT 8,3;" from memory.            ";
           AT 9,3;TAB 28;" ";
          AT 10,3;TAB 28;" ";
          AT 11,3;TAB 28;" "
3200 PRINT AT 18,2; FLASH 1;"Press key to return to menu.":
     IF INKEY$="" THEN GO TO 3200
3210 BEEP .1,5: GO TO 22

3500 REM Save characters
3510 GO SUB cls
3520 PRINT AT 3,7; INVERSE 1; INK 3;"SAVEing Characters"
3530 PRINT AT 5,3;"This will save the entire";
           AT 6,3;"program and all the";
           AT 7,3;"characters and it will";
           AT 8,3;"take approx. 1 min 13 secs."
3540 LET z$="Y": SAVE "Character" LINE 1
3560 PRINT AT 18,5; FLASH 1;"Do you want to VERIFY?"
3570 LET z$=INKEY$:
     IF z$="y" OR z$="Y" THEN
       LET z$="Y": BEEP .1,5: PRINT AT 10,3;: VERIFY "":
       PRINT AT 18,3;"Verified O.K.          "
3575 IF z$="" THEN GO TO 3570
3580 BEEP .1,5: GO SUB 9050: GO TO 22

9000 REM Clear Screen
9010 FOR x=2 TO 19
9020   PRINT AT x,2; BRIGHT 1;TAB 29;" "
9030 NEXT x
9040 RETURN

9050 REM Border
9051 BRIGHT 0
9055 PRINT AT  0,0;"{J} {J} {J} {J} {J} {J} {J} {J} {D}{E}{D}{E}{D}{E}{D}{E}{D}{E}{D}{E}{D}{E}{D}{E}{K}{L}{K}{L}{K}{L}{K}{L}{K}{L}{K}{L}{K}{L}{K}{L}{F} {F} {F} {F} {F} {F} {F} {F} "
9060 FOR x=2 TO 8 STEP 2
9065   PRINT AT x,0;"{J} ";AT x,30;" {E} {L}";AT x+1,30;"{F} "
9070 NEXT x
9075 FOR x=10 TO 18 STEP 2
9080   PRINT AT x,0;" {A}";AT x,30;"{G} {C} ";AT x+1,30;" {I}"
9085 NEXT x
9090 PRINT AT 20,0;" {A} {A} {A} {A} {A} {A} {A} {A}{G}{H}{G}{H}{G}{H}{G}{H}{G}{H}{G}{H}{G}{H}{G}{H}{C}{B}{C}{B}{C}{B}{C}{B}{C}{B}{C}{B}{C}{B}{C}{B} {I} {I} {I} {I} {I} {I} {I} {I}"
9095 BRIGHT 1: RETURN

9850 REM Options
9855 RESTORE 9890: FOR x=1 TO 7: READ o$(x): NEXT x
9860 RETURN
9890 DATA "1 List character sheet.",
          "2 Adjust character sheet.",
          "3 Copy character sheet.",
          "4 Enter new character.",
          "5 Clear one character.",
          "6 Clear all characters.",
          "7 Save character sheets."

9900 RESTORE 9980
9905 FOR q=144 TO 155
9910   FOR x=0 TO 7: READ b: POKE USR CHR$ q+x,b: NEXT x
9915 NEXT q
9920 RETURN
9980 DATA 0,0,4,8,16,48,96,192
9981 DATA 128,0,0,0,0,0,0,0
9982 DATA 33,19,14,12,28,114,33,0
9983 DATA 0,0,0,0,0,0,0,1
9984 DATA 0,132,78,56,48,112,200,132
9985 DATA 3,6,12,8,16,32,0,0
9986 DATA 0,0,32,16,12,6,3,1
9987 DATA 0,0,0,0,0,0,0,128
9988 DATA 194,100,56,56,76,134,4,0
9989 DATA 0,32,97,50,28,28,38,67
9990 DATA 1,0,0,0,0,0,0,0
9991 DATA 128,192,96,48,8,4,0,0